// RUN: stablehlo-opt -inline %s | stablehlo-translate --interpret
// RUN: stablehlo-translate --serialize --target=current %s | stablehlo-translate --deserialize | stablehlo-opt > %t.0
// RUN: stablehlo-opt %s > %t.1
// RUN: diff %t.0 %t.1

module @jit_testcase {
  func.func public @main() -> tensor<i1> {
    %0:2 = call @inputs() : () -> (tensor<3x3xf16>, tensor<3x3xf16>)
    %1 = call @expected() : () -> tensor<3x3xf16>
    %2 = stablehlo.minimum %0#0, %0#1 : tensor<3x3xf16>
    %3 = stablehlo.custom_call @check.eq(%2, %1) : (tensor<3x3xf16>, tensor<3x3xf16>) -> tensor<i1>
    return %3 : tensor<i1>
  }
  func.func private @inputs() -> (tensor<3x3xf16>, tensor<3x3xf16>) {
    %0 = stablehlo.constant dense<[[0x7E00, 0x7E00, 0x7E00], [0x7C00, 0x7C00, 0x7C00], [0xFC00, 0xFC00, 0xFC00]]> : tensor<3x3xf16>
    %1 = stablehlo.constant dense<[[0x7E00, 0x7C00, 0xFC00], [0x7E00, 0x7C00, 0xFC00], [0x7E00, 0x7C00, 0xFC00]]> : tensor<3x3xf16>
    return %0, %1 : tensor<3x3xf16>, tensor<3x3xf16>
  }
  func.func private @expected() -> tensor<3x3xf16> {
    %0 = stablehlo.constant dense<[[0x7E00, 0x7E00, 0x7E00], [0x7E00, 0x7C00, 0xFC00], [0x7E00, 0xFC00, 0xFC00]]> : tensor<3x3xf16>
    return %0 : tensor<3x3xf16>
  }
}
