// RUN: stablehlo-opt -inline %s | stablehlo-translate --interpret
// RUN: stablehlo-translate --serialize --target=current %s | stablehlo-translate --deserialize | stablehlo-opt > %t.0
// RUN: stablehlo-opt %s > %t.1
// RUN: diff %t.0 %t.1

module @jit_testcase {
  func.func public @main() -> tensor<i1> {
    %0 = call @inputs() : () -> tensor<2x3xf16>
    %1 = call @expected() : () -> tensor<3xf16>
    %2 = stablehlo.constant dense<0.000000e+00> : tensor<f16>
    %3 = stablehlo.reduce(%0 init: %2) across dimensions = [0] : (tensor<2x3xf16>, tensor<f16>) -> tensor<3xf16>
     reducer(%arg0: tensor<f16>, %arg1: tensor<f16>)  {
      %5 = stablehlo.add %arg0, %arg1 : tensor<f16>
      stablehlo.return %5 : tensor<f16>
    }
    %4 = stablehlo.custom_call @check.eq(%3, %1) : (tensor<3xf16>, tensor<3xf16>) -> tensor<i1>
    return %4 : tensor<i1>
  }
  func.func private @inputs() -> tensor<2x3xf16> {
    %0 = stablehlo.constant dense<[[1.864260e+00, -3.166020e+00, 1.846920e-01], [2.681640e+00, -2.515630e+00, 6.015630e+00]]> : tensor<2x3xf16>
    return %0 : tensor<2x3xf16>
  }
  func.func private @expected() -> tensor<3xf16> {
    %0 = stablehlo.constant dense<[4.546880e+00, -5.679690e+00, 6.199210e+00]> : tensor<3xf16>
    return %0 : tensor<3xf16>
  }
}
