// RUN: stablehlo-opt -inline %s | stablehlo-translate --interpret
// RUN: stablehlo-translate --serialize --target=current %s | stablehlo-translate --deserialize | stablehlo-opt > %t.0
// RUN: stablehlo-opt %s > %t.1
// RUN: diff %t.0 %t.1

module @jit_testcase {
  func.func public @main() -> tensor<i1> {
    %0 = stablehlo.constant dense<[0, 4]> : tensor<2xi32>
    %1:2 = call @inputs() : () -> (tensor<4x2x3x5xi8>, tensor<4x3xi8>)
    %2 = call @expected() : () -> tensor<4x2x3x5xi8>
    %3 = "stablehlo.scatter"(%1#0, %0, %1#1) ({
    ^bb0(%arg0: tensor<i8>, %arg1: tensor<i8>):
      %5 = stablehlo.maximum %arg0, %arg1 : tensor<i8>
      stablehlo.return %5 : tensor<i8>
    }) {scatter_dimension_numbers = #stablehlo.scatter<update_window_dims = [0, 1], inserted_window_dims = [1, 3], scatter_dims_to_operand_dims = [1, 3]>, unique_indices = true} : (tensor<4x2x3x5xi8>, tensor<2xi32>, tensor<4x3xi8>) -> tensor<4x2x3x5xi8>
    %4 = stablehlo.custom_call @check.eq(%3, %2) : (tensor<4x2x3x5xi8>, tensor<4x2x3x5xi8>) -> tensor<i1>
    return %4 : tensor<i1>
  }
  func.func private @inputs() -> (tensor<4x2x3x5xi8>, tensor<4x3xi8>) {
    %0 = stablehlo.constant dense<"0x03FCFDFE02000002FB0300FC040305FF0100010000FF0101FF010000FC0000FD00FE03FFFF000102FFFA01050000FEFFFF000304FF01FFFD01000002FFFEF901FCFE00FF00FE00FD00FE0501FDFC000001020300010000FD0000FE02000202000000FD01040002FE01F7030600FE0303FC05FBFCFFFE0101"> : tensor<4x2x3x5xi8>
    %1 = stablehlo.constant dense<[[3, 1, 0], [-1, -3, -5], [-4, 0, 0], [-1, -1, 0]]> : tensor<4x3xi8>
    return %0, %1 : tensor<4x2x3x5xi8>, tensor<4x3xi8>
  }
  func.func private @expected() -> tensor<4x2x3x5xi8> {
    %0 = stablehlo.constant dense<"0x03FCFDFE03000002FB0300FC040305FF0100010000FF0101FF010000FC0000FD00FE03FFFF000102FFFA01050000FEFFFF000304FF01FFFD01000002FFFEF901FCFE00FF000000FD00FE0501FDFC000001020300010000FD0000FE02000202000000FD01040002FE01F7030600FE0303FC05FBFCFFFE0101"> : tensor<4x2x3x5xi8>
    return %0 : tensor<4x2x3x5xi8>
  }
}

